using System;
using System.Collections;

namespace Esempio1
{
    public class Point : IComparable
    {
        private int _x, _y;

        public Point(int x, int y)
        {
            _x = x;
            _y = y;
        }

        public int X
        {
            get { return _x; }
            set { _x = value; }
        }

        public int Y
        {
            get { return _y; }
            set { _y = value; }
        }

        public override string ToString()
        {
            return "(" + X.ToString() + "," + Y.ToString() + ")";
        }

        #region IComparable Members

        public int CompareTo(object obj)
        {
            if (obj == null)
                return 1;
            //  if(!(obj is Point))  //  utilizzabile solo se class sealed Point o struct Point
            if (obj.GetType() != GetType())  //  class Point (utilizzabile sempre)
                throw new ArgumentException();
            Point p = (Point) obj;
            return (X != p.X) ? (X - p.X) : (Y - p.Y);
        }

        #endregion

        public class Comparer : IComparer
        {
            private readonly bool _up;

            public Comparer(bool up = true)
            {
                _up = up;
            }

            #region IComparer Members

            public int Compare(object obj1, object obj2)
            {
                if (obj1 != null && !(obj1 is Point))
                    throw new ArgumentException();
                if (obj2 != null && !(obj2 is Point))
                    throw new ArgumentException();
                int retCode;
                if (obj1 == obj2)
                    retCode = 0;
                else if (obj1 == null)
                    retCode = -1;
                else if (obj2 == null)
                    retCode = 1;
                else
                    retCode = ((Point) obj1).CompareTo(obj2);
                return (_up ? retCode : -retCode);
            }

            #endregion
        }
    }
}
